#include <math.h>
#include <stdio.h>

float f1(float u, float v) { return u; }
float f2(float u, float v) { return v; }
float f3(float u, float v) { return cos(u*u + v*v); }

float g1(float u, float v) { return u; }
float g2(float u, float v) { return v; }
float g3(float u, float v) { return u*u - v*v; }

#include "div.c"

void main(void) {

  int n = 0, planura = 15, linearidade = 15;
  float ang_max, borda_max, umin = -1, umax = 1, vmin = -1, vmax = 1,
	inc_u, inc_v;

  n = QuantasSubdivisoes(f1, f2, f3, -2, 2, -2, 2, planura, linearidade, 500);
  printf("\nN_subdivisoes = %d   Planura <= %d graus   Linearidade <= "
				      "%d graus \n", n, planura, linearidade);
  n = 50;
  inc_u = (umax - umin)/n, inc_v = (vmax - vmin)/n;
  ang_max =  AnguloMax(f1, f2, f3, umin, umax,
			 vmin, vmax, inc_u, inc_v, 1e30);
  borda_max =  BordasMax(f1, f2, f3, umin, umax,
			 vmin, vmax, inc_u, inc_v, 1e30);

  printf("\nN = %d   (norm) ang_max = %f graus  (tang) borda_max = %f graus",
   n, ang_max*180.0/M_PI, borda_max*180.0/M_PI);

  if (n) Tec3(f1, f2, f3, g1, g2, g3, umin, umax, vmin, vmax, n);
}
